import datetime

from django.test import TestCase
from django.utils import timezone
from .models import Grouped_order


class GroupedOrderModelTests(TestCase):

    def test_is_ongoing_with_ongoing_grouped_order(self):
        """
        is_ongoing() returns True if the deadline is not crossed
        """
        deadline = timezone.now() + datetime.timedelta(days=10)
        ongoing_gr_order = Grouped_order(deadline=deadline)
        self.assertIs(ongoing_gr_order.is_ongoing(), True)

    def test_is_ongoing_with_old_grouped_order(self):
        """
        is_ongoing() returns False if the deadline is crossed
        """
        deadline = timezone.now() - datetime.timedelta(hours=1)
        ongoing_gr_order = Grouped_order(deadline=deadline)
        self.assertIs(ongoing_gr_order.is_ongoing(), False)

